Bug 744024 - ipa-client-install return code indicates a success, even though it failed
Summary: ipa-client-install return code indicates a success, even though it failed
Keywords:
Status: CLOSED ERRATA
Alias: None
Product: Red Hat Enterprise Linux 6
Classification: Red Hat
Component: ipa
Version: 6.1
Hardware: Unspecified
OS: Unspecified
unspecified
unspecified
Target Milestone: rc
: ---
Assignee: Rob Crittenden
QA Contact: IDM QE LIST
URL:
Whiteboard:
Depends On:
Blocks:
TreeView+ depends on / blocked
 
Reported: 2011-10-06 18:58 UTC by Namita Soman
Modified: 2011-12-06 18:42 UTC (History)
3 users (show)

Fixed In Version: ipa-2.1.2-1.el6
Doc Type: Bug Fix
Doc Text:
Cause: ipa-client-install may return success return code even when the installation has failed Consequence: Automated tools running ipa-client-install cannot use the return code to tell if the installation was successful and would have to parse its output Fix: Proper error code is returned when ipa-client-install fails Result: Automated tools can use the return code to check if the installation was successful
Clone Of:
Environment:
Last Closed: 2011-12-06 18:42:19 UTC
Target Upstream Version:


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Product Errata RHSA-2011:1533 normal SHIPPED_LIVE Moderate: ipa security and bug fix update 2011-12-06 01:23:31 UTC

Description Namita Soman 2011-10-06 18:58:30 UTC
Description of problem:
Running a ipa-client-install, that fails, has an exit code of 0

> ipa-client-install --domain=abc -p XXX -w XXX  -U
will throw an error:
Unable to find IPA Server to join
Installation failed. Rolling back changes.
IPA client is not configured on this system.

And then 
> echo $?
indicates a zero
as if ipa-client was installed successfully, but looks like this return code is to say that when install failed, it uninstalled successfully....which is not as expected, since I'm checking the status of the client install I just attempted.



Version-Release number of selected component (if applicable):
ipa-client-2.1.1-4.el6.x86_64

How reproducible:
always

Steps to Reproduce:
1. run a bad install command like:
ipa-client=install 
or
ipa-client-install --domain=abc -p XXX -w XXX  -U
2. Error is thrown to indicate the client install failed
3. Check exit status 
echo $?
  
Actual results:
0

Expected results:
1

Additional info:

Comment 4 Dmitri Pal 2011-10-07 03:46:57 UTC
Upstream ticket:
https://fedorahosted.org/freeipa/ticket/1937

Comment 9 Namita Soman 2011-10-11 11:36:34 UTC
Verified using ipa-client-2.1.2-2.el6.x86_64


# ipa-client-install -U
One of password and principal are required.
Installation failed. Rolling back changes.
IPA client is not configured on this system.

# echo $?
1

Comment 10 Martin Kosek 2011-10-31 20:30:52 UTC
    Technical note added. If any revisions are required, please edit the "Technical Notes" field
    accordingly. All revisions will be proofread by the Engineering Content Services team.
    
    New Contents:
Cause: ipa-client-install may return success return code even when the installation has failed
Consequence: Automated tools running ipa-client-install cannot use the return code to tell if the installation was successful and would have to parse its output
Fix: Proper error code is returned when ipa-client-install fails
Result: Automated tools can use the return code to check if the installation was successful

Comment 11 errata-xmlrpc 2011-12-06 18:42:19 UTC
Since the problem described in this bug report should be
resolved in a recent advisory, it has been closed with a
resolution of ERRATA.

For information on the advisory, and where to find the updated
files, follow the link below.

If the solution does not work for you, open a new bug report.

http://rhn.redhat.com/errata/RHSA-2011-1533.html


Note You need to log in before you can comment on or make changes to this bug.